import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ce, useState as _, useMemo as f, useEffect as me, useRef as w, useCallback as je } from "react";
import { isMobile as D } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as de, Table as B, Skeleton as ge } from "antd";
import pe from "../../BitzDrawer/index.mjs";
import Ne from "../../BitzLoadMore/index.mjs";
import ye from "../../BitzPagination/index.mjs";
import ve from "../../BitzNoData/index.mjs";
import we, { TableContext as Be } from "../Store/index.mjs";
import Ce from "../TableSkeleton/index.mjs";
import { columnSort as ze, genColumnKey as F } from "../Store/utils/index.mjs";
import K from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import Me from "../../../node_modules/lodash-es/at.mjs";
const Te = ({
  tableItemEmit: j = () => {
  },
  showPagination: V = !0,
  fillEvenRow: C = !0,
  evenRowBgColor: z = "#f9f9f9",
  height: g,
  dataSource: s = [],
  total: p = 0,
  columns: x,
  loading: b = !1,
  skeletonNum: $ = 2,
  skeletonRender: M,
  skeletonRowNum: A = 4,
  skeletonRowsWidth: R = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: U = () => {
  },
  mobileLoadEmit: X = () => {
  },
  mobileRefreshEmit: q = () => {
  },
  operations: G = [],
  enableControlPage: J,
  pagination: Q,
  paginationEmit: W = () => {
  },
  mobilePageHeight: Y = 500,
  mobileCancelText: Z = "取消",
  noDataTitle: I,
  noDataImg: S,
  color: ee,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: T,
  showTableTool: se = !0,
  tableAction: ne,
  tableToolbar: le,
  selectionBar: ie,
  scroll: o,
  resetPage: re,
  ...a
}) => {
  de.useToken();
  const t = ce(Be), [oe, N] = _(!1), [te, xe] = _({}), ae = f(() => (s == null ? void 0 : s.length) == p && (s == null ? void 0 : s.length) > 0, [s, p]), he = (l) => {
    N(!0), xe(l), j(l);
  }, k = () => {
    N(!1);
  }, fe = (l) => {
    N(!1), U(l.type, te);
  }, c = f(() => {
    const l = (r) => r.map((i) => {
      const P = F(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), m = t.columnsMap[P];
      return m && m.show === !1 ? !1 : i.children ? {
        ...i,
        children: l(i.children)
      } : i;
    }).filter(Boolean), n = l(x);
    return [
      B.SELECTION_COLUMN,
      B.EXPAND_COLUMN,
      ...n.sort(ze(t.columnsMap))
    ];
  }, [t.columnsMap, x]);
  me(() => {
    if (x && x.length > 0) {
      const l = x.map(
        (n) => (
          // @ts-ignore
          F((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      t.setSortKeyColumns(l);
    }
  }, [x]);
  const d = w(null), y = K(d), u = w(null), h = K(u), { y: v } = f(() => {
    if (typeof g > "u")
      return {};
    let l = 40, n = 40;
    if (d.current) {
      const m = window.getComputedStyle(d.current);
      l = parseInt(
        m.getPropertyValue("--cell-block") || "40"
      ), n = parseInt(
        m.getPropertyValue("--toolbar-height") || "40"
      );
    }
    const r = h == null ? void 0 : h.height;
    return { y: g - (r || 0) - n - l };
  }, [g, h == null ? void 0 : h.height, y == null ? void 0 : y.height]), be = w(null), L = f(() => o != null && o.x ? { x: o.x, y: o.y || v } : o != null && o.y ? s != null && s.length ? { x: 1e3, y: o.y } : { x: 1e3 } : s != null && s.length ? { x: 1e3, y: v } : { x: 1e3 }, [s, o, v]), E = f(() => `${T ?? (t == null ? void 0 : t.tableSize) ?? "lg"}BitzTable`, [T, t.tableSize]), H = f(() => ({
    "--evenRow-BgColor": z
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    z
    /** token.Table?.borderColor */
  ]), O = je(
    (l, n) => C ? n % 2 === 0 ? "oddRow" : "evenRow" : "",
    [C]
  );
  return /* @__PURE__ */ e.jsxs("div", { className: "bitzTableBlock", children: [
    !D && /* @__PURE__ */ e.jsxs(
      "div",
      {
        ref: d,
        className: `bitzTableContainer ${E}`,
        children: [
          /* @__PURE__ */ e.jsxs("div", { className: "bitzTableContainerBody", ref: be, children: [
            se && /* @__PURE__ */ e.jsxs("div", { className: "bitzTableToolbarBlock", children: [
              ne || /* @__PURE__ */ e.jsx("div", {}),
              le,
              (a == null ? void 0 : a.rowSelection) && /* @__PURE__ */ e.jsx(e.Fragment, { children: ie })
            ] }),
            b ? /* @__PURE__ */ e.jsx(
              Ce,
              {
                columns: c,
                dataLength: s == null ? void 0 : s.length,
                scroll: L,
                rowSelection: a.rowSelection,
                expandable: a.expandable,
                className: E,
                style: H,
                rowClassName: O
              }
            ) : /* @__PURE__ */ e.jsx(
              B,
              {
                columns: c,
                dataSource: s,
                loading: b,
                pagination: !1,
                scroll: L,
                ...a,
                style: H,
                rowClassName: O
              }
            )
          ] }),
          V && /* @__PURE__ */ e.jsx(
            ye,
            {
              ref: u,
              enableControl: J,
              pagination: Q,
              total: p,
              dataSource: s,
              resetPage: re,
              paginationEmit: W
            }
          )
        ]
      }
    ),
    D && /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
      (b || (s == null ? void 0 : s.length) > 0) && /* @__PURE__ */ e.jsx(
        Ne,
        {
          color: ee,
          height: Y,
          showNoMore: ae,
          refreshEmit: q,
          loadEmit: X,
          extra: /* @__PURE__ */ e.jsxs("div", { className: "mobileTable", children: [
            s == null ? void 0 : s.map((l, n) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: c == null ? void 0 : c.map((r, i) => /* @__PURE__ */ e.jsx("div", { children: !(r != null && r.mobileHide) && /* @__PURE__ */ e.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    he(l);
                  },
                  children: [
                    /* @__PURE__ */ e.jsxs("div", { className: "label", children: [
                      r.title,
                      "："
                    ] }),
                    /* @__PURE__ */ e.jsx("div", { className: "value", children: r.render(
                      Me(l, r == null ? void 0 : r.dataIndex),
                      l,
                      n
                    ) })
                  ]
                }
              ) }, i)) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            b && Array.from({ length: $ }).map((l, n) => /* @__PURE__ */ e.jsxs("div", { children: [
              /* @__PURE__ */ e.jsx("div", { className: "rowBox", children: M ? M() : /* @__PURE__ */ e.jsx(
                ge,
                {
                  title: !1,
                  paragraph: {
                    rows: A,
                    width: R
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ e.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            /* @__PURE__ */ e.jsx(
              pe,
              {
                className: "tableMobileDrawer",
                open: oe,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: k,
                children: /* @__PURE__ */ e.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ e.jsx("div", { className: "boxBody", children: G.map((l, n) => /* @__PURE__ */ e.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        fe(l);
                      },
                      children: l.label
                    },
                    n
                  )) }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ e.jsx("div", { className: "boxFooter", onClick: k, children: Z })
                ] })
              }
            )
          ] })
        }
      ),
      !b && /* @__PURE__ */ e.jsx(ve, { data: s, title: I, img: S })
    ] })
  ] });
}, Re = (j) => (
  // @ts-ignore
  /* @__PURE__ */ e.jsx(we, { initValue: j, children: /* @__PURE__ */ e.jsx(Te, { ...j }) })
);
export {
  Re as default
};
