import { j as e } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as X, useModal as Y, antdModalV5 as Z } from "@ebay/nice-modal-react";
import { Modal as _, Checkbox as $ } from "antd";
import t from "./index.module.less.mjs";
import { useState as g, useContext as L, useEffect as ss, useCallback as T, useMemo as y } from "react";
import { TableContext as es } from "../../Store/index.mjs";
import { genColumnKey as A, columnSort as os } from "../../Store/utils/index.mjs";
import B from "../../../../node_modules/classnames/index.mjs";
import { DndContext as ls, DragOverlay as ts, defaultDropAnimationSideEffects as ns } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { SortableContext as as, verticalListSortingStrategy as cs, arrayMove as is } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import rs from "./DndItem.mjs";
import { restrictToVerticalAxis as ms, restrictToWindowEdges as ds } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import O from "../../../BitzButton/index.mjs";
import "./index.less.mjs";
import { useImmer as us } from "../../../../node_modules/use-immer/dist/use-immer.module.mjs";
import ps from "../../../../assets/iconfont/IconTuodong.mjs";
import z from "../../../../node_modules/lodash-es/omit.mjs";
import xs from "../../../../node_modules/@ant-design/icons/es/icons/CheckCircleOutlined.mjs";
import hs from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
const fs = {
  sideEffects: ns({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, zs = X(() => {
  var I;
  const x = Y(), [u, j] = g(null), [R, v] = g(!1), [c, h] = us({
    columnsMap: {},
    sortKeyColumns: []
  }), {
    persistenceType: V,
    persistenceKey: k,
    onlineChange: C,
    columnsMap: F,
    setColumnsMap: W,
    sortKeyColumns: q,
    setSortKeyColumns: G,
    // clearPersistenceStorage,
    ...l
  } = L(es);
  ss(() => {
    h((s) => {
      s.columnsMap = { ...F }, s.sortKeyColumns = [...q];
    });
  }, []);
  const H = T(() => {
    h((s) => {
      s.columnsMap = { ...l.defaultColumnKeyMap };
    });
  }, []), p = y(() => {
    var o, n;
    const s = [];
    return (o = l == null ? void 0 : l.columns) != null && o.length && ((n = l == null ? void 0 : l.columns) == null || n.map(({ key: d, dataIndex: a, ...r }) => {
      const f = A(
        d || a,
        [d || a].filter(Boolean).join("-")
      ), m = c.columnsMap[f || "null"];
      return (m == null ? void 0 : m.show) !== !1 && s.push({
        key: f,
        ...z(r, ["className"]),
        selectable: !1,
        disabled: (m == null ? void 0 : m.disable) === !0
      }), m;
    })), s.sort(os(c.columnsMap));
  }, [c.columnsMap, l == null ? void 0 : l.columns]), M = T(
    (s) => {
      var o;
      return (o = c.sortKeyColumns) == null ? void 0 : o.findIndex((n) => n === s);
    },
    [c.sortKeyColumns]
  ), N = y(
    () => u ? M(u) : -1,
    [u, M]
  ), S = y(() => {
    const s = [], o = /* @__PURE__ */ new Map();
    return { list: ((d, a) => d.map(({ key: r, dataIndex: f, children: m, ...w }) => {
      var E;
      const b = A(
        r || f,
        [a == null ? void 0 : a.columnKey, w.index].filter(Boolean).join("-")
      ), i = c.columnsMap[b || "null"] || { show: !0 };
      (i == null ? void 0 : i.show) !== !1 && !m && s.push(b);
      const D = {
        key: b,
        ...z(w, ["className"]),
        selectable: !1,
        disabled: i.disable === !0,
        disableCheckbox: typeof i.disable == "boolean" ? i == null ? void 0 : i.disable : (E = i == null ? void 0 : i.disable) == null ? void 0 : E.checkbox,
        isLeaf: a ? !0 : void 0
      };
      return o.set(r, D), D;
    }))(l == null ? void 0 : l.columns), keys: s, map: o };
  }, [c.columnsMap, l == null ? void 0 : l.columns]), J = (s, o) => {
    const n = { ...c.columnsMap };
    ((a) => {
      const r = { ...n[a] };
      r.show = !s, n[a] = r;
    })(o.key), v(!0), h((a) => {
      a.columnsMap = { ...n };
    });
  }, P = (s, o) => {
    const n = { ...c.columnsMap }, d = is(c.sortKeyColumns, s, o);
    d.forEach((a, r) => {
      n[a] = { ...n[a] || {}, order: r };
    }), v(!0), h((a) => {
      a.columnsMap = { ...n }, a.sortKeyColumns = d;
    });
  }, Q = y(() => {
    var s, o;
    return u ? ((o = (s = l == null ? void 0 : l.columns) == null ? void 0 : s.find((n) => n.key === u)) == null ? void 0 : o.title) ?? "" : "";
  }, [l == null ? void 0 : l.columns, u]), U = () => {
    W(c.columnsMap), G(c.sortKeyColumns), V === "online" && k && (C == null || C(k, c.columnsMap)), x.resolve({ ...c.columnsMap }), x.hide();
  }, K = () => {
    x.hide();
  };
  return /* @__PURE__ */ e.jsxs(
    _,
    {
      className: "tableColumnSettingModal",
      title: "自定义列",
      ...Z(x),
      width: 600,
      onCancel: K,
      footer: /* @__PURE__ */ e.jsxs(e.Fragment, { children: [
        /* @__PURE__ */ e.jsx(
          O,
          {
            type: "primary",
            icon: /* @__PURE__ */ e.jsx(xs, {}),
            onClick: U,
            disabled: !R,
            children: "保存"
          }
        ),
        /* @__PURE__ */ e.jsx(O, { onClick: K, children: "取消" })
      ] }),
      children: [
        /* @__PURE__ */ e.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
        /* @__PURE__ */ e.jsxs("div", { className: t.container, children: [
          /* @__PURE__ */ e.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ e.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ e.jsx("div", { className: t.title, children: "可用列" }),
              /* @__PURE__ */ e.jsx("div", {})
            ] }),
            /* @__PURE__ */ e.jsx("div", { className: t.body, children: /* @__PURE__ */ e.jsx("ul", { className: t.content, children: (I = S.list) == null ? void 0 : I.map((s) => {
              const o = S.keys.includes(s.key);
              return /* @__PURE__ */ e.jsxs(
                "li",
                {
                  className: B(t.item, {
                    [t.checked]: !o
                  }),
                  onClick: () => !s.disabled && J(o, s),
                  children: [
                    /* @__PURE__ */ e.jsx($, { checked: o, disabled: s.disabled }),
                    /* @__PURE__ */ e.jsx("span", { className: t["content-item-text"], children: s.title })
                  ]
                },
                s.key
              );
            }) }) })
          ] }),
          /* @__PURE__ */ e.jsxs("div", { className: t.block, children: [
            /* @__PURE__ */ e.jsxs("div", { className: t.header, children: [
              /* @__PURE__ */ e.jsx("div", { className: t.title, children: "选定列" }),
              /* @__PURE__ */ e.jsxs("div", { className: t.reset, onClick: H, children: [
                /* @__PURE__ */ e.jsx("div", { children: "重置  " }),
                /* @__PURE__ */ e.jsx(hs, {})
              ] })
            ] }),
            /* @__PURE__ */ e.jsx("div", { className: t.body, children: /* @__PURE__ */ e.jsxs(
              ls,
              {
                modifiers: [ms, ds],
                onDragStart: (s) => {
                  const { active: o } = s;
                  o && j(o == null ? void 0 : o.id);
                },
                onDragCancel: () => j(null),
                onDragEnd: (s) => {
                  j(null);
                  const { over: o } = s;
                  if (o) {
                    const n = M(o.id);
                    N !== n && P(N, n);
                  }
                },
                children: [
                  /* @__PURE__ */ e.jsx(
                    as,
                    {
                      items: p == null ? void 0 : p.map((s) => s.key),
                      strategy: cs,
                      children: /* @__PURE__ */ e.jsx("ul", { className: t.content, style: { background: "#fff" }, children: p == null ? void 0 : p.map((s) => /* @__PURE__ */ e.jsx(rs, { item: s }, s.key)) })
                    }
                  ),
                  /* @__PURE__ */ e.jsx(ts, { adjustScale: !1, dropAnimation: fs, children: u ? /* @__PURE__ */ e.jsxs("li", { className: B(t.moveItem), children: [
                    /* @__PURE__ */ e.jsx(ps, { size: 14, className: t.dragIcon }),
                    /* @__PURE__ */ e.jsx("span", { className: t["moveItem-text"], children: Q })
                  ] }) : null })
                ]
              }
            ) })
          ] })
        ] })
      ]
    }
  );
});
export {
  zs as default
};
